## fortran-toml 0.4.2

=== CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.9)
get_directory_property(is-subproject PARENT_DIRECTORY)

project(
  "toml-f"
  LANGUAGES "Fortran"
  VERSION "0.4.2"
  DESCRIPTION "A TOML parser implementation for data serialization and deserialization in Fortran"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

# General configuration information
add_subdirectory("config")

# Collect source of the project
set(srcs)
add_subdirectory("src")

# TOML-Fortran library target
add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)
set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${PROJECT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${PROJECT_BINARY_DIR}/include"
)
target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)
if(NOT EXISTS "${PROJECT_BINARY_DIR}/include")
   make_directory("${PROJECT_BINARY_DIR}/include")
endif()

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${PROJECT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "LICENSE-Apache"
  "LICENSE-MIT"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

# add the testsuite
enable_testing()
set(fpm-toml "${PROJECT_SOURCE_DIR}/fpm.toml")
add_subdirectory("test")

=== config/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)

set(
  "${PROJECT_NAME}-module-dir"
  "${PROJECT_NAME}/modules"
  CACHE STRING
  "Subdirectory to install generated module files to"
)
set(
  module-dir
  "${${PROJECT_NAME}-module-dir}"
)
set(module-dir "${module-dir}" PARENT_SCOPE)

# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" PARENT_SCOPE)

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY SameMinorVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.pc"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== doc/requirements.txt ===
ablog
sphinx-book-theme~=0.3.3
sphinx-copybutton
sphinx-design
urllib3<2

=== src/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory("tomlf")

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/tomlf.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== test/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Version consistency checker.
add_subdirectory("version")

# Unit testing
add_subdirectory("unit")

# Validation tests
add_subdirectory("compliance")

=== src/tomlf/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory("build")
add_subdirectory("de")
add_subdirectory("structure")
add_subdirectory("type")
add_subdirectory("utils")

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/all.f90"
  "${dir}/build.f90"
  "${dir}/constants.f90"
  "${dir}/datetime.f90"
  "${dir}/de.f90"
  "${dir}/diagnostic.f90"
  "${dir}/error.f90"
  "${dir}/ser.f90"
  "${dir}/structure.f90"
  "${dir}/terminal.f90"
  "${dir}/type.f90"
  "${dir}/utils.f90"
  "${dir}/version.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== test/unit/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(NOT TARGET "test-drive::test-drive")
  find_package("test-drive")
endif()

set(
  test-srcs
  "build.f90"
  "lexer.f90"
  "main.f90"
  "parser.f90"
  "sort.f90"
  "utils.f90"
)

add_executable(
  tftester
  "${test-srcs}"
)
target_link_libraries(
  tftester
  PRIVATE
  "${PROJECT_NAME}-lib"
  "test-drive::test-drive"
)
add_test(
  "tftest"
  tftester
)

=== test/version/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(${CMAKE_VERSION} VERSION_GREATER "3.18")
  # Required for policy change
  cmake_policy(SET CMP0110 NEW)
endif()

# Check for consistency of the internal version number with the one defined
# in the projects meson.build
add_executable(
  ${PROJECT_NAME}-test-version
  "version.f90"
)
target_link_libraries(
  ${PROJECT_NAME}-test-version
  PRIVATE
  "${PROJECT_NAME}-lib"
)
add_test(
  "${PROJECT_NAME}/version"
  ${PROJECT_NAME}-test-version
  "${PROJECT_VERSION}"
)

# Check if the version in the fpm.toml package file matches the internal version
add_executable(
  ${PROJECT_NAME}-test-fpm
  "fpm.f90"
)
target_link_libraries(
  ${PROJECT_NAME}-test-fpm
  PRIVATE
  "${PROJECT_NAME}-lib"
)
add_test(
  "${PROJECT_NAME}/fpm"
  ${PROJECT_NAME}-test-fpm
  "${fpm-toml}"
)

=== src/tomlf/build/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/array.f90"
  "${dir}/keyval.f90"
  "${dir}/merge.f90"
  "${dir}/path.f90"
  "${dir}/table.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/tomlf/de/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/abc.f90"
  "${dir}/context.f90"
  "${dir}/lexer.f90"
  "${dir}/parser.f90"
  "${dir}/token.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/tomlf/structure/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/array_list.f90"
  "${dir}/list.f90"
  "${dir}/map.f90"
  "${dir}/node.f90"
  "${dir}/ordered_map.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/tomlf/type/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/array.f90"
  "${dir}/keyval.f90"
  "${dir}/table.f90"
  "${dir}/value.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== debian/changelog ===
fortran-toml (0.4.2-5) unstable; urgency=medium

  * pkgconf.patch: Ensure path is correct in toml-f.pc

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Oct 2025 09:57:27 +0000

fortran-toml (0.4.2-4) unstable; urgency=medium

  * Rebuild against updated fortran-testdrive, dh-fortran-mod

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 25 Oct 2025 10:48:55 +0100

fortran-toml (0.4.2-3) unstable; urgency=medium

  * Changes for dh-fortran-mod >= 0.48
  * Mark Multi-Arch: same
  * Build-dep on gfortran

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 19 Oct 2025 09:14:27 +0100

fortran-toml (0.4.2-2) unstable; urgency=medium

  * Add debian/watch file
  * pkgconf.patch: Fix paths
  * Build-dep on pkgconf

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 Sep 2025 08:51:34 +0100

fortran-toml (0.4.2-1) experimental; urgency=medium

  * Initial release. (Closes: #1112188)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 27 Aug 2025 11:49:07 +0100

=== debian/control ===
Source: fortran-toml
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Standards-Version: 4.7.2
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-fortran-mod,
 gfortran,
 libfortran-testdrive-dev,
 pkgconf,
 meson
Homepage: https://github.com/toml-f/toml-f
Vcs-Browser: https://salsa.debian.org/science-team/fortran-toml.git
Vcs-Git: https://salsa.debian.org/science-team/fortran-toml.git

Package: libfortran-toml-dev
Architecture: any
Depends: ${misc:Depends},${fortran:Depends},
 libfortran-toml-0 ( = ${binary:Version})
Recommends: pkgconf
Description: Fortran TOML parser library - devel files
 A TOML parser implementation for data serialization and 
 deserialization in Fortran.

Package: libfortran-toml-0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fortran TOML parser library 
 A TOML parser implementation for data serialization and 
 deserialization in Fortran.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --with fortran


override_dh_auto_clean:
	rm -rf build subprojects/toml-test-1.1.0 subprojects/packagecache/v*.gz subprojects/test-drive

override_dh_auto_configure:
	meson setup build --prefix=$(CURDIR)/debian/tmp/usr

override_dh_auto_build:
	meson compile -C build	

override_dh_auto_test:
	@echo Bypass tests this build. require downloads

override_dh_auto_install:
	meson install -C build

## fortran-toml 0.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,12 +17,13 @@
 project(
   "toml-f"
   LANGUAGES "Fortran"
-  VERSION "0.4.2"
+  VERSION "0.4.3"
   DESCRIPTION "A TOML parser implementation for data serialization and deserialization in Fortran"
 )
 
 # Follow GNU conventions for installing directories
 include(GNUInstallDirs)
+include(CTest) # option(BUILD_TESTING). ON by default.
 
 # General configuration information
 add_subdirectory("config")
@@ -53,7 +54,7 @@
   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
 )
 if(NOT EXISTS "${PROJECT_BINARY_DIR}/include")
-   make_directory("${PROJECT_BINARY_DIR}/include")
+   file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/include")
 endif()
 
 # Export targets for other projects
@@ -89,6 +90,8 @@
 )
 
 # add the testsuite
-enable_testing()
-set(fpm-toml "${PROJECT_SOURCE_DIR}/fpm.toml")
-add_subdirectory("test")
+if(BUILD_TESTING)
+  enable_testing()
+  set(fpm-toml "${PROJECT_SOURCE_DIR}/fpm.toml")
+  add_subdirectory("test")
+endif()

=== meson_options.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option('tests', type: 'boolean', value: true, description: 'Enable building and running tests')

=== doc/requirements.txt ===
ablog
sphinx-book-theme~=1.0.0
sphinx-copybutton
sphinx-design
urllib3<2

=== test/compliance/CMakeLists.txt ===
# This file is part of toml-f.
# SPDX-Identifier: Apache-2.0 OR MIT
#
# Licensed under either of Apache License, Version 2.0 or MIT license
# at your option; you may not use this file except in compliance with
# the License.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Serializer from TOML to a specific JSON format suitable for the validator suite
add_executable(
  toml2json
  "json_ser.f90"
  "toml2json.f90"
)
target_link_libraries(
  toml2json
  PRIVATE
  "${PROJECT_NAME}-lib"
)

# Deserializer for a specific JSON format suitable for the validator suite
add_executable(
  json2toml
  "json_lexer.f90"
  "json_parser.f90"
  "json2toml.f90"
)
target_link_libraries(
  json2toml
  PRIVATE
  "${PROJECT_NAME}-lib"
)

=== test/version/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-if(${CMAKE_VERSION} VERSION_GREATER "3.18")
+if(POLICY CMP0110)
   # Required for policy change
   cmake_policy(SET CMP0110 NEW)
 endif()

=== debian/changelog ===
fortran-toml (0.4.3-2) unstable; urgency=medium

  * Move dh-fortran-mod -> dh-fortran
  * d/watch: Move to version 5 syntax
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Add Section: needed for dh-fortran autodetection
  * Update pkg-config file generation ; no longer hard-code paths in patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Jan 2026 15:11:23 +0000

fortran-toml (0.4.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Nov 2025 15:24:54 +0000

=== debian/control ===
Source: fortran-toml
Section: utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Standards-Version: 4.7.3
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-fortran (>= 0.58),
 gfortran,
 libfortran-testdrive-dev,
 pkgconf,
 meson
Homepage: https://github.com/toml-f/toml-f
Vcs-Browser: https://salsa.debian.org/science-team/fortran-toml
Vcs-Git: https://salsa.debian.org/science-team/fortran-toml.git -b debian/latest

Package: libfortran-toml-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},${fortran:Depends},
 libfortran-toml-0 ( = ${binary:Version})
Recommends: pkgconf
Description: Fortran TOML parser library - devel files
 A TOML parser implementation for data serialization and 
 deserialization in Fortran.

Package: libfortran-toml-0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fortran TOML parser library 
 A TOML parser implementation for data serialization and 
 deserialization in Fortran.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,11 @@
 #!/usr/bin/make -f
 
 export DH_VERBOSE=1
+
+FMODDIR:=$(shell dh_fortran get_fmoddir)
+FLIBDIR:=$(shell dh_fortran get_flibdir)
+
+PKGFILE=debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/toml-f.pc
 
 # The magic debhelper  rule
 %:
@@ -21,3 +26,7 @@
 
 override_dh_auto_install:
 	meson install -C build
+	sed -i -e 's%@FMODDIR@%${FMODDIR}%' $(PKGFILE)
+	sed -i -e 's%@FLIBDIR@%${FLIBDIR}%' $(PKGFILE)
+	sed -i -e 's%{libdir}%{flibdir}%' $(PKGFILE)
+	sed -i -e 's%{includedir}%{fmoddir}%g' $(PKGFILE)

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/toml-f/toml-f
